/*
 *  dinkelbach.cpp
 *  PHunterLib
 *
 *  Created by Tiayyba Riaz on 6/7/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

//#include <iostream>
//#include <strstream>
//#include <cstring>
#include "nnparams.h"
#include "galign.h"
#include "dinkelbach.h"

void dnkl_initdinkelbach(pdinkelbach dnkl, PNNParams myDiParams, GGAlign mGAlign)
{
  dnkl->myDinkParams = myDiParams;
  dnkl->myGAlign = mGAlign;
}


int dnkl_iteration(pdinkelbach dnkl, float TempK)
{
  int iteration = 0;
  nparam_AlterTM(dnkl->myDinkParams, TempK);
  float precursor_oldTM = TempK;
  float newTM = TempK;
  float oldTM = TempK, lambda, oldlambda;
  lambda = 999999999999999999.9;
  int positive=0;

  do
  {
    iteration++;
    galn_InitBorder(dnkl->myGAlign);
    galn_CalculateTable(dnkl->myGAlign, 1);
    oldlambda=lambda;
    lambda =galn_GetFreeEnergyK(dnkl->myGAlign, dnkl->myGAlign->maxloci,dnkl->myGAlign->maxlocj,newTM);
    if(lambda < 0.0) 
    {
	if(!positive) 
	{
		//Initial melting temperature greater than expected
		newTM = galn_GetEnthalpy(dnkl->myGAlign, dnkl->myGAlign->maxloci,dnkl->myGAlign->maxlocj)/galn_GetEntropy(dnkl->myGAlign, dnkl->myGAlign->maxloci,dnkl->myGAlign->maxlocj)-1;
		lambda = oldlambda;
		nparam_AlterTM(dnkl->myDinkParams, newTM);
	} 
	else 
	{
		precursor_oldTM = oldTM;
	}
    } 
    else 
    {
	positive = 1;
    	oldTM = newTM;
    	newTM = galn_GetMeltingTempK(dnkl->myGAlign, dnkl->myGAlign->maxloci,dnkl->myGAlign->maxlocj);
    	nparam_AlterTM(dnkl->myDinkParams, newTM);
    }
  }
  while(!positive || (newTM - oldTM > 0.001  && (lambda>0.0)&&(lambda<oldlambda)));

  if(newTM - oldTM > 0.001 && ((lambda<0.0)||(lambda>oldlambda)))
  {
    iteration++;
    nparam_AlterTM(dnkl->myDinkParams, precursor_oldTM);
    galn_InitBorder(dnkl->myGAlign);
    galn_CalculateTable(dnkl->myGAlign, 1);
    lambda = galn_GetFreeEnergyK(dnkl->myGAlign, dnkl->myGAlign->maxloci,dnkl->myGAlign->maxlocj,precursor_oldTM);
    newTM = galn_GetMeltingTempK(dnkl->myGAlign, dnkl->myGAlign->maxloci,dnkl->myGAlign->maxlocj);
    nparam_AlterTM(dnkl->myDinkParams, newTM);
  }
  return iteration;
}
